!test the massive curvaton 10 - large field inflation functions
program mchi10main
  use infprec, only : kp, transfert
  use cosmopar, only : lnRhoNuc
  use infinout, only : delete_file, livewrite
  use mchisr, only : mchi_potential,mchi_phiend0
  use mchi10reheat, only : mchi10_ns, mchi10_r, mchi10_fnl, mchi10_isnormalizable, &
                            mchi10_M, mchi10_bfoldstar, mchi10_Pzeta_sigma
  use curvaton, only : MC10_sigmaend_min, MC10_sigmaend_max

  implicit none

  integer :: i, j, k, l
  integer :: Nmsigma, NGammaphi, NGammasigma, Nsigmaend
  real(kp) ::  sigmaend, msigma, Gammaphi, Gammasigma, M, Psigma
  real(kp) ::  Gammaphimin, Gammaphimax, Gammasigmamin, Gammasigmamax, msigmamin, msigmamax, &
               sigmaendmin, sigmaendmax
  real(kp) :: ns, r, fnl, security, bfoldstar
  type(transfert) :: Vparam

  Nmsigma = 20
  NGammaphi = 20
  NGammasigma = 10
  Nsigmaend = 20

  security = 0.8_kp

  Gammasigmamin=sqrt(exp(lnRhoNuc)/3._kp)

  M = 4._kp*10.**(-5) !Fiducial Value
  Gammaphimax = M**2
  Gammaphimin = Gammasigmamin/security**9
  msigmamin = Gammasigmamin/security**9

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!                       !!!!
!!!!        pred           !!!!
!!!!                       !!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


  Vparam%real1 = M

  call delete_file('mchi10_predic.dat')

  do i=0,NGammaphi
    print*, '     ###################     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ##  completed:   ##     '
    print*, '     ##  ',i,'/',Nmsigma,'         ##     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ###################     '
    Gammaphi=Gammaphimin*(Gammaphimax/Gammaphimin)**(real(i,kp)/real(NGammaphi,kp))
    !Gammaphi=Gammaphimax*exp(log(Gammaphimin/Gammaphimax)*1._kp/(1._kp+10._kp*real(i,kp)/real(NGammaphi,kp))) !prefers sampling higher values
    msigmamax=Gammaphi!*security
    msigmamin=sqrt(6._kp)*Gammaphi/20._kp ! just to avoid wasting useless parameter space exploration. . Otherwise, would be Gammasigmamin.
    do j=0,Nmsigma
      !msigma=msigmamin*(msigmamax/msigmamin)**(real(j,kp)/real(Nmsigma,kp))
      msigma=msigmamax*exp(log(msigmamin/msigmamax)*1._kp/(1._kp+10._kp*real(j,kp)/real(Nmsigma,kp))) !prefers sampling higher values
      Gammasigmamax=msigma!*security**9
      do k=0,NGammasigma
        !Gammasigma=Gammasigmamin*(Gammasigmamax/Gammasigmamin)**(real(j,kp)/real(NGammasigma,kp))
        Gammasigma=Gammasigmamax*exp(log(Gammasigmamin/Gammasigmamax)*1._kp/(1._kp+10._kp*real(k,kp)/real(NGammasigma,kp))) !prefers sampling higher values
        sigmaendmax=20._kp ! 20 is to avoid wasting exploring useless parameters space (if sigmaend>20, impossible to normalize M)
        sigmaendmin=MC10_sigmaend_min(msigma,Gammaphi,Gammasigma)/security
        do l=0,Nsigmaend
          sigmaend=sigmaendmin*(sigmaendmax/sigmaendmin)**(real(l,kp)/real(Nsigmaend,kp))
          if (mchi10_isnormalizable(msigma, Gammaphi, Gammasigma, sigmaend)) then
            M = mchi10_M(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            Vparam%real1 = M
            if (sigmaend < MC10_sigmaend_max(mchi_potential,mchi_phiend0,&
                    Vparam,msigma,Gammaphi,Gammasigma)) then ! check that sigmaend does not domimate the energy content at the end of inflation
              ns = mchi10_ns(msigma, Gammaphi, Gammasigma, sigmaend)
              r = mchi10_r(msigma, Gammaphi, Gammasigma, sigmaend)
              fnl = mchi10_fnl(msigma, Gammaphi, Gammasigma, sigmaend)
              Psigma = mchi10_Pzeta_sigma(msigma, Gammaphi, Gammasigma, sigmaend)
              Vparam%real1 = M
              bfoldstar = mchi10_bfoldstar(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
              print*, 'M = ',M, 'Gammaphi', Gammaphi,'msigma=', msigma, 'Gammasigma=', Gammasigma, &
                  'sigmaend=', sigmaend
              print*, ' efoldstar=',-bfoldstar,' ns=',ns,' r=',r, 'fnl=',fnl, 'Psigma=',Psigma
              call livewrite('mchi10_predic.dat',M,msigma,Gammaphi,Gammasigma,sigmaend,ns,r,fnl,Psigma)
            end if
          end if
        end do
      end do
    end do
  end do



end program mchi10main
