!test the massive curvaton 1 - large field inflation functions
program mchi3main
  use infprec, only : kp, transfert
  use cosmopar, only : lnRhoNuc
  use infinout, only : delete_file, livewrite
  use mchi3reheat, only : mchi3_ns, mchi3_r, mchi3_fnl, mchi3_isnormalizable, mchi3_M, &
                           mchi3_bfoldstar, mchi3_Pzeta_sigma
  use mchisr, only : mchi_potential,mchi_phiend0
  use curvaton, only : MC3_sigmaend_min, MC3_sigmaend_max

  implicit none

  integer :: i, j, k, l
  integer :: Nmsigma, NGammaphi, NGammasigma, Nsigmaend
  real(kp) ::  sigmaend, msigma, Gammaphi, Gammasigma, M, Psigma
  real(kp) ::  Gammaphimin, Gammaphimax, Gammasigmamin, Gammasigmamax, msigmamin, msigmamax, &
               sigmaendmin, sigmaendmax
  real(kp) :: ns, r, fnl, security, bfoldstar
  type(transfert) :: Vparam

  Nmsigma = 20
  NGammaphi = 20
  NGammasigma = 10
  Nsigmaend = 20

  security = 0.8_kp

  Gammaphimin=sqrt(exp(lnRhoNuc)/3._kp)

  M = 4._kp*10.**(-5) !Fiducial Value
  msigmamax = M**2
  msigmamin = Gammaphimin/security**2
  Gammasigmamin = Gammaphimin/security


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!                       !!!!
!!!!         pred          !!!!
!!!!                       !!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


  Vparam%real1 = M

  call delete_file('mchi3_predic.dat')

  do i=0,Nmsigma
    print*, '     ###################     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ##  completed:   ##     '
    print*, '     ##  ',i,'/',Nmsigma,'         ##     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ###################     '
    msigma=msigmamin*(msigmamax/msigmamin)**(real(i,kp)/real(Nmsigma,kp))
    !msigma=msigmamax*exp(log(msigmamin/msigmamax)*1._kp/(1._kp+10._kp*real(i,kp)/real(Nmsigma,kp))) !prefers sampling higher values
    Gammasigmamax=msigma!*security
    do j=0,NGammasigma
      !Gammasigma=Gammasigmamin*(Gammasigmamax/Gammasigmamin)**(real(j,kp)/real(NGammasigma,kp))
      Gammasigma=Gammasigmamax*exp(log(Gammasigmamin/Gammasigmamax)*1._kp/(1._kp+10._kp*real(j,kp)/real(NGammasigma,kp))) !prefers sampling higher values
      Gammaphimax=Gammasigma!*security
      do k=0,NGammaphi
        !Gammaphi=Gammaphimin*(Gammaphimax/Gammaphimin)**(real(j,kp)/real(NGammaphi,kp))
        Gammaphi=Gammaphimax*exp(log(Gammaphimin/Gammaphimax)*1._kp/(1._kp+10._kp*real(k,kp)/real(NGammaphi,kp))) !prefers sampling higher values
        sigmaendmax = 20._kp ! 20 is to avoid wasting exploring useless parameters space (if sigmaend>20, impossible to normalize M)
        sigmaendmin=MC3_sigmaend_min(msigma,Gammaphi,Gammasigma)/security
        if (sigmaendmin < sigmaendmax) then
          do l=0,Nsigmaend
            sigmaend=sigmaendmin*(sigmaendmax/sigmaendmin)**(real(l,kp)/real(Nsigmaend,kp))
            !sigmaend=sigmaendmax*exp(log(sigmaendmin/sigmaendmax)*1._kp/(1._kp+100._kp*real(l,kp)/real(Nsigmaend,kp))) !prefers sampling higher values
            if (mchi3_isnormalizable(msigma, Gammaphi, Gammasigma, sigmaend)) then
              M = mchi3_M(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
              Vparam%real1 = M
              if (sigmaend < MC3_sigmaend_max(mchi_potential,mchi_phiend0,Vparam,msigma,Gammaphi,Gammasigma)) then ! check that sigmaend does not domimate the energy content at the end of inflation
                ns = mchi3_ns(msigma, Gammaphi, Gammasigma, sigmaend)
                r = mchi3_r(msigma, Gammaphi, Gammasigma, sigmaend)
                fnl = mchi3_fnl(msigma, Gammaphi, Gammasigma, sigmaend)
                Psigma = mchi3_Pzeta_sigma(msigma, Gammaphi, Gammasigma, sigmaend)
                bfoldstar = mchi3_bfoldstar(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
                print*, 'M = ',M, 'Gammaphi', Gammaphi,'msigma=', msigma, 'Gammasigma=', &
                   Gammasigma, 'sigmaend=', sigmaend
                print*, ' efoldstar=',-bfoldstar,' ns=',ns,' r=',r, 'fnl=',fnl, 'Psigma=',Psigma
                call livewrite('mchi3_predic.dat',M,msigma,Gammaphi,Gammasigma,sigmaend,ns,r,fnl,Psigma)
              end if
            end if
          end do
        end if
      end do
    end do
  end do


end program mchi3main
