!test the massive curvaton 1 - large field inflation functions
program mchi5main
  use infprec, only : kp, transfert
  use cosmopar, only : lnRhoNuc
  use infinout, only : delete_file, livewrite
  use mchi5reheat, only : mchi5_ns, mchi5_r, mchi5_fnl, mchi5_isnormalizable, mchi5_M, &
                           mchi5_bfoldstar, mchi5_Pzeta_sigma
  use curvaton, only : MC5_sigmaend_min, MC5_sigmaend_max

  implicit none

  integer :: i, j, k, l
  integer :: Nmsigma, NGammaphi, NGammasigma, Nsigmaend
  real(kp) ::  sigmaend, msigma, Gammaphi, Gammasigma, M, Psigma
  real(kp) ::  Gammaphimin, Gammaphimax, Gammasigmamin, Gammasigmamax, msigmamin, msigmamax, &
               sigmaendmin, sigmaendmax
  real(kp) :: ns, r, fnl, security, bfoldstar
  type(transfert) :: Vparam

  Nmsigma = 20
  NGammaphi = 20
  NGammasigma = 10
  Nsigmaend = 20

  security = 0.8_kp

  Gammasigmamin=sqrt(exp(lnRhoNuc)/3._kp)

  M = 4._kp*10.**(-5) !Fiducial Value
  msigmamax = M**2
  msigmamin = Gammasigmamin/security**9
  Gammaphimin = Gammasigmamin/security**9

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!                       !!!!
!!!!        pred           !!!!
!!!!                       !!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



  Vparam%real1 = M

  call delete_file('mchi5_predic.dat')

  do i=0,Nmsigma
    print*, '     ###################     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ##  completed:   ##     '
    print*, '     ##  ',i,'/',Nmsigma,'         ##     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ###################     '
    msigma=msigmamin*(msigmamax/msigmamin)**(real(i,kp)/real(Nmsigma,kp))
    !msigma=msigmamax*exp(log(msigmamin/msigmamax)*1._kp/(1._kp+10._kp*real(i,kp)/real(Nmsigma,kp))) !prefers sampling higher values
    Gammaphimax=msigma!*security
    do j=0,NGammaphi
      !Gammaphi=Gammaphimin*(Gammaphimax/Gammaphimin)**(real(j,kp)/real(NGammaphi,kp))
      Gammaphi=Gammaphimax*exp(log(Gammaphimin/Gammaphimax)*1._kp/(1._kp+10._kp*real(j,kp)/real(NGammaphi,kp))) !prefers sampling higher values
      Gammasigmamax=Gammaphi*security**9
      do k=0,NGammasigma
        !Gammasigma=Gammasigmamin*(Gammasigmamax/Gammasigmamin)**(real(j,kp)/real(NGammasigma,kp))
        Gammasigma=Gammasigmamax*exp(log(Gammasigmamin/Gammasigmamax)*1._kp/(1._kp+10._kp*real(k,kp)/real(NGammasigma,kp))) !prefers sampling higher values
        sigmaendmax=MC5_sigmaend_max(msigma,Gammaphi,Gammasigma)*security
        sigmaendmin=MC5_sigmaend_min(msigma,Gammaphi,Gammasigma)/security
        do l=0,Nsigmaend
          sigmaend=sigmaendmin*(sigmaendmax/sigmaendmin)**(real(l,kp)/real(Nsigmaend,kp))
          !sigmaend=sigmaendmax*exp(log(sigmaendmin/sigmaendmax)*1._kp/(1._kp+100._kp*real(l,kp)/real(Nsigmaend,kp))) !prefers sampling higher values
          if (mchi5_isnormalizable(msigma, Gammaphi, Gammasigma, sigmaend)) then
            M = mchi5_M(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            ns = mchi5_ns(msigma, Gammaphi, Gammasigma, sigmaend)
            r = mchi5_r(msigma, Gammaphi, Gammasigma, sigmaend)
            fnl = mchi5_fnl(msigma, Gammaphi, Gammasigma, sigmaend)
            Psigma = mchi5_Pzeta_sigma(msigma, Gammaphi, Gammasigma, sigmaend)
            Vparam%real1 = M
            bfoldstar = mchi5_bfoldstar(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            print*, 'M = ',M, 'Gammaphi', Gammaphi,'msigma=', msigma, 'Gammasigma=', Gammasigma, &
                  'sigmaend', sigmaend
            print*, ' efoldstar=',-bfoldstar,' ns=',ns,' r=',r, 'fnl=',fnl, 'Psigma=',Psigma
            call livewrite('mchi5_predic.dat',M,msigma,Gammaphi,Gammasigma,sigmaend,ns,r,fnl,Psigma)
          end if
        end do
      end do
    end do
  end do



end program mchi5main
