!test the massive curvaton 10 - large field inflation functions
program mclfi10main
  use infprec, only : kp, transfert
  use cosmopar, only : lnRhoNuc
  use infinout, only : delete_file, livewrite
  use mclfisr, only : mclfi_potential,mclfi_phiend0
  use mclfi10reheat, only : mclfi10_ns, mclfi10_r, mclfi10_fnl, mclfi10_isnormalizable, &
                            mclfi10_M, mclfi10_bfoldstar, mclfi10_Pzeta_sigma
  use curvaton, only : MC10_sigmaend_min, MC10_sigmaend_max

  implicit none

  integer :: i, j, k, l
  integer :: Nmsigma, NGammaphi, NGammasigma, Nsigmaend
  real(kp) ::  sigmaend, msigma, Gammaphi, Gammasigma, M, p, Psigma
  real(kp) ::  Gammaphimin, Gammaphimax, Gammasigmamin, Gammasigmamax, msigmamin, msigmamax, &
               sigmaendmin, sigmaendmax
  real(kp) :: ns, r, fnl, security, bfoldstar
  type(transfert) :: Vparam

  Nmsigma = 20
  NGammaphi = 20
  NGammasigma = 10
  Nsigmaend = 20

  security = 0.8_kp

  Gammasigmamin=sqrt(exp(lnRhoNuc)/3._kp)

  M = 5._kp*10.**(-3) !Fiducial Value
  Gammaphimax = M**2
  Gammaphimin = Gammasigmamin/security**9
  msigmamin = Gammasigmamin/security**9

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!                       !!!!
!!!!         p=4           !!!!
!!!!                       !!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   p=4._kp

  Vparam%real1 = M
  Vparam%real2 = p

  call delete_file('mclfi10_peq4_predic.dat')

  do i=0,NGammaphi
    print*, '     ###################     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ##  completed:   ##     '
    print*, '     ##  ',i,'/',Nmsigma,'         ##     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ###################     '
    Gammaphi=Gammaphimin*(Gammaphimax/Gammaphimin)**(real(i,kp)/real(NGammaphi,kp))
    !Gammaphi=Gammaphimax*exp(log(Gammaphimin/Gammaphimax)*1._kp/(1._kp+10._kp*real(i,kp)/real(NGammaphi,kp))) !prefers sampling higher values
    msigmamax=Gammaphi!*security
    msigmamin=sqrt(6._kp)*Gammaphi/20._kp ! just to avoid wasting useless parameter space exploration. . Otherwise, would be Gammasigmamin.
    do j=0,Nmsigma
      !msigma=msigmamin*(msigmamax/msigmamin)**(real(j,kp)/real(Nmsigma,kp))
      msigma=msigmamax*exp(log(msigmamin/msigmamax)*1._kp/(1._kp+10._kp*real(j,kp)/real(Nmsigma,kp))) !prefers sampling higher values
      Gammasigmamax=msigma!*security**9
      do k=0,NGammasigma
        !Gammasigma=Gammasigmamin*(Gammasigmamax/Gammasigmamin)**(real(j,kp)/real(NGammasigma,kp))
        Gammasigma=Gammasigmamax*exp(log(Gammasigmamin/Gammasigmamax)*1._kp/(1._kp+10._kp*real(k,kp)/real(NGammasigma,kp))) !prefers sampling higher values
        sigmaendmax=20._kp ! 20 is to avoid wasting exploring useless parameters space (if sigmaend>20, impossible to normalize M)
        sigmaendmin=MC10_sigmaend_min(msigma,Gammaphi,Gammasigma)/security
        do l=0,Nsigmaend
          sigmaend=sigmaendmin*(sigmaendmax/sigmaendmin)**(real(l,kp)/real(Nsigmaend,kp))
          if (mclfi10_isnormalizable(p, msigma, Gammaphi, Gammasigma, sigmaend)) then
            M = mclfi10_M(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            Vparam%real1 = M
            if (sigmaend < MC10_sigmaend_max(mclfi_potential,mclfi_phiend0,&
                    Vparam,msigma,Gammaphi,Gammasigma)) then ! check that sigmaend does not domimate the energy content at the end of inflation
              ns = mclfi10_ns(p, msigma, Gammaphi, Gammasigma, sigmaend)
              r = mclfi10_r(p, msigma, Gammaphi, Gammasigma, sigmaend)
              fnl = mclfi10_fnl(p, msigma, Gammaphi, Gammasigma, sigmaend)
              Psigma = mclfi10_Pzeta_sigma(p, msigma, Gammaphi, Gammasigma, sigmaend)
              Vparam%real1 = M
              bfoldstar = mclfi10_bfoldstar(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
              print*, 'p=',p,'M = ',M, 'Gammaphi', Gammaphi,'msigma=', msigma, 'Gammasigma=', Gammasigma, &
                  'sigmaend=', sigmaend
              print*, ' efoldstar=',-bfoldstar,' ns=',ns,' r=',r, 'fnl=',fnl, 'Psigma=',Psigma
              call livewrite('mclfi10_peq4_predic.dat',M,msigma,Gammaphi,Gammasigma,sigmaend,ns,r,fnl,Psigma)
            end if
          end if
        end do
      end do
    end do
  end do




!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!                       !!!!
!!!!         p=2           !!!!
!!!!                       !!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  p=2._kp

  Vparam%real1 = M
  Vparam%real2 = p

  call delete_file('mclfi10_peq2_predic.dat')

  do i=0,NGammaphi
    print*, '     ###################     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ##  completed:   ##     '
    print*, '     ##  ',i,'/',Nmsigma,'         ##     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ###################     '
    Gammaphi=Gammaphimin*(Gammaphimax/Gammaphimin)**(real(i,kp)/real(NGammaphi,kp))
    !Gammaphi=Gammaphimax*exp(log(Gammaphimin/Gammaphimax)*1._kp/(1._kp+10._kp*real(i,kp)/real(NGammaphi,kp))) !prefers sampling higher values
    msigmamax=Gammaphi!*security
    msigmamin=sqrt(6._kp)*Gammaphi/20._kp ! just to avoid wasting useless parameter space exploration. . Otherwise, would be Gammasigmamin.
    do j=0,Nmsigma
      !msigma=msigmamin*(msigmamax/msigmamin)**(real(j,kp)/real(Nmsigma,kp))
      msigma=msigmamax*exp(log(msigmamin/msigmamax)*1._kp/(1._kp+10._kp*real(j,kp)/real(Nmsigma,kp))) !prefers sampling higher values
      Gammasigmamax=msigma!*security**9
      do k=0,NGammasigma
        !Gammasigma=Gammasigmamin*(Gammasigmamax/Gammasigmamin)**(real(j,kp)/real(NGammasigma,kp))
        Gammasigma=Gammasigmamax*exp(log(Gammasigmamin/Gammasigmamax)*1._kp/(1._kp+10._kp*real(k,kp)/real(NGammasigma,kp))) !prefers sampling higher values
        sigmaendmax=20._kp ! 20 is to avoid wasting exploring useless parameters space (if sigmaend>20, impossible to normalize M)
        sigmaendmin=MC10_sigmaend_min(msigma,Gammaphi,Gammasigma)/security
        do l=0,Nsigmaend
          sigmaend=sigmaendmin*(sigmaendmax/sigmaendmin)**(real(l,kp)/real(Nsigmaend,kp))
          if (mclfi10_isnormalizable(p, msigma, Gammaphi, Gammasigma, sigmaend)) then
            M = mclfi10_M(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            Vparam%real1 = M
            if (sigmaend < MC10_sigmaend_max(mclfi_potential,mclfi_phiend0,&
                    Vparam,msigma,Gammaphi,Gammasigma)) then ! check that sigmaend does not domimate the energy content at the end of inflation
              ns = mclfi10_ns(p, msigma, Gammaphi, Gammasigma, sigmaend)
              r = mclfi10_r(p, msigma, Gammaphi, Gammasigma, sigmaend)
              fnl = mclfi10_fnl(p, msigma, Gammaphi, Gammasigma, sigmaend)
              Psigma = mclfi10_Pzeta_sigma(p, msigma, Gammaphi, Gammasigma, sigmaend)
              Vparam%real1 = M
              bfoldstar = mclfi10_bfoldstar(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
              print*, 'p=',p,'M = ',M, 'Gammaphi', Gammaphi,'msigma=', msigma, 'Gammasigma=', Gammasigma, &
                  'sigmaend=', sigmaend
              print*, ' efoldstar=',-bfoldstar,' ns=',ns,' r=',r, 'fnl=',fnl, 'Psigma=',Psigma
              call livewrite('mclfi10_peq2_predic.dat',M,msigma,Gammaphi,Gammasigma,sigmaend,ns,r,fnl,Psigma)
            end if
          end if
        end do
      end do
    end do
  end do


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!                       !!!!
!!!!         p=6           !!!!
!!!!                       !!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  p=6._kp

  Vparam%real1 = M
  Vparam%real2 = p

  call delete_file('mclfi10_peq6_predic.dat')

  do i=0,NGammaphi
    print*, '     ###################     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ##  completed:   ##     '
    print*, '     ##  ',i,'/',Nmsigma,'         ##     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ###################     '
    Gammaphi=Gammaphimin*(Gammaphimax/Gammaphimin)**(real(i,kp)/real(NGammaphi,kp))
    !Gammaphi=Gammaphimax*exp(log(Gammaphimin/Gammaphimax)*1._kp/(1._kp+10._kp*real(i,kp)/real(NGammaphi,kp))) !prefers sampling higher values
    msigmamax=Gammaphi!*security
    msigmamin=sqrt(6._kp)*Gammaphi/20._kp ! just to avoid wasting useless parameter space exploration. . Otherwise, would be Gammasigmamin.
    do j=0,Nmsigma
      !msigma=msigmamin*(msigmamax/msigmamin)**(real(j,kp)/real(Nmsigma,kp))
      msigma=msigmamax*exp(log(msigmamin/msigmamax)*1._kp/(1._kp+10._kp*real(j,kp)/real(Nmsigma,kp))) !prefers sampling higher values
      Gammasigmamax=msigma!*security**9
      do k=0,NGammasigma
        !Gammasigma=Gammasigmamin*(Gammasigmamax/Gammasigmamin)**(real(j,kp)/real(NGammasigma,kp))
        Gammasigma=Gammasigmamax*exp(log(Gammasigmamin/Gammasigmamax)*1._kp/(1._kp+10._kp*real(k,kp)/real(NGammasigma,kp))) !prefers sampling higher values
        sigmaendmax=20._kp ! 20 is to avoid wasting exploring useless parameters space (if sigmaend>20, impossible to normalize M)
        sigmaendmin=MC10_sigmaend_min(msigma,Gammaphi,Gammasigma)/security
        do l=0,Nsigmaend
          sigmaend=sigmaendmin*(sigmaendmax/sigmaendmin)**(real(l,kp)/real(Nsigmaend,kp))
          if (mclfi10_isnormalizable(p, msigma, Gammaphi, Gammasigma, sigmaend)) then
            M = mclfi10_M(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            Vparam%real1 = M
            if (sigmaend < MC10_sigmaend_max(mclfi_potential,mclfi_phiend0,&
                    Vparam,msigma,Gammaphi,Gammasigma)) then ! check that sigmaend does not domimate the energy content at the end of inflation
              ns = mclfi10_ns(p, msigma, Gammaphi, Gammasigma, sigmaend)
              r = mclfi10_r(p, msigma, Gammaphi, Gammasigma, sigmaend)
              fnl = mclfi10_fnl(p, msigma, Gammaphi, Gammasigma, sigmaend)
              Psigma = mclfi10_Pzeta_sigma(p, msigma, Gammaphi, Gammasigma, sigmaend)
              Vparam%real1 = M
              bfoldstar = mclfi10_bfoldstar(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
              print*, 'p=',p,'M = ',M, 'Gammaphi', Gammaphi,'msigma=', msigma, 'Gammasigma=', Gammasigma, &
                  'sigmaend=', sigmaend
              print*, ' efoldstar=',-bfoldstar,' ns=',ns,' r=',r, 'fnl=',fnl, 'Psigma=',Psigma
              call livewrite('mclfi10_peq6_predic.dat',M,msigma,Gammaphi,Gammasigma,sigmaend,ns,r,fnl,Psigma)
            end if
          end if
        end do
      end do
    end do
  end do


end program mclfi10main
