!test the massive curvaton 1 - large field inflation functions
program mclfi5main
  use infprec, only : kp, transfert
  use cosmopar, only : lnRhoNuc
  use infinout, only : delete_file, livewrite
  use mclfi5reheat, only : mclfi5_ns, mclfi5_r, mclfi5_fnl, mclfi5_isnormalizable, mclfi5_M, &
                           mclfi5_bfoldstar, mclfi5_Pzeta_sigma
  use curvaton, only : MC5_sigmaend_min, MC5_sigmaend_max

  implicit none

  integer :: i, j, k, l
  integer :: Nmsigma, NGammaphi, NGammasigma, Nsigmaend
  real(kp) ::  sigmaend, msigma, Gammaphi, Gammasigma, M, p, Psigma
  real(kp) ::  Gammaphimin, Gammaphimax, Gammasigmamin, Gammasigmamax, msigmamin, msigmamax, &
               sigmaendmin, sigmaendmax
  real(kp) :: ns, r, fnl, security, bfoldstar
  type(transfert) :: Vparam

  Nmsigma = 20
  NGammaphi = 20
  NGammasigma = 10
  Nsigmaend = 20

  security = 0.8_kp

  Gammasigmamin=sqrt(exp(lnRhoNuc)/3._kp)

  M = 5._kp*10.**(-3) !Fiducial Value
  msigmamax = sqrt(M)
  msigmamin = Gammasigmamin/security**9
  Gammaphimin = Gammasigmamin/security**9

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!                       !!!!
!!!!         p=4           !!!!
!!!!                       !!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  p=4._kp

  Vparam%real1 = M
  Vparam%real2 = p

  call delete_file('mclfi5_peq4_predic.dat')

  do i=0,Nmsigma
    print*, '     ###################     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ##  completed:   ##     '
    print*, '     ##  ',i,'/',Nmsigma,'         ##     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ###################     '
    msigma=msigmamin*(msigmamax/msigmamin)**(real(i,kp)/real(Nmsigma,kp))
    !msigma=msigmamax*exp(log(msigmamin/msigmamax)*1._kp/(1._kp+10._kp*real(i,kp)/real(Nmsigma,kp))) !prefers sampling higher values
    Gammaphimax=msigma!*security
    do j=0,NGammaphi
      !Gammaphi=Gammaphimin*(Gammaphimax/Gammaphimin)**(real(j,kp)/real(NGammaphi,kp))
      Gammaphi=Gammaphimax*exp(log(Gammaphimin/Gammaphimax)*1._kp/(1._kp+10._kp*real(j,kp)/real(NGammaphi,kp))) !prefers sampling higher values
      Gammasigmamax=Gammaphi*security**9
      do k=0,NGammasigma
        !Gammasigma=Gammasigmamin*(Gammasigmamax/Gammasigmamin)**(real(j,kp)/real(NGammasigma,kp))
        Gammasigma=Gammasigmamax*exp(log(Gammasigmamin/Gammasigmamax)*1._kp/(1._kp+10._kp*real(k,kp)/real(NGammasigma,kp))) !prefers sampling higher values
        sigmaendmax=MC5_sigmaend_max(msigma,Gammaphi,Gammasigma)*security
        sigmaendmin=MC5_sigmaend_min(msigma,Gammaphi,Gammasigma)/security
        do l=0,Nsigmaend
          sigmaend=sigmaendmin*(sigmaendmax/sigmaendmin)**(real(l,kp)/real(Nsigmaend,kp))
          !sigmaend=sigmaendmax*exp(log(sigmaendmin/sigmaendmax)*1._kp/(1._kp+100._kp*real(l,kp)/real(Nsigmaend,kp))) !prefers sampling higher values
          if (mclfi5_isnormalizable(p, msigma, Gammaphi, Gammasigma, sigmaend)) then
            M = mclfi5_M(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            ns = mclfi5_ns(p, msigma, Gammaphi, Gammasigma, sigmaend)
            r = mclfi5_r(p, msigma, Gammaphi, Gammasigma, sigmaend)
            fnl = mclfi5_fnl(p, msigma, Gammaphi, Gammasigma, sigmaend)
            Psigma = mclfi5_Pzeta_sigma(p, msigma, Gammaphi, Gammasigma, sigmaend)
            Vparam%real1 = M
            bfoldstar = mclfi5_bfoldstar(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            print*, 'p=',p,'M = ',M, 'Gammaphi', Gammaphi,'msigma=', msigma, 'Gammasigma=', Gammasigma, &
                  'sigmaend', sigmaend
            print*, ' efoldstar=',-bfoldstar,' ns=',ns,' r=',r, 'fnl=',fnl, 'Psigma=',Psigma
            call livewrite('mclfi5_peq4_predic.dat',M,msigma,Gammaphi,Gammasigma,sigmaend,ns,r,fnl,Psigma)
          end if
        end do
      end do
    end do
  end do


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!                       !!!!
!!!!         p=2           !!!!
!!!!                       !!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  p=2._kp

  Vparam%real1 = M
  Vparam%real2 = p

  call delete_file('mclfi5_peq2_predic.dat')

  do i=0,Nmsigma
    print*, '     ###################     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ##  completed:   ##     '
    print*, '     ##  ',i,'/',Nmsigma,'         ##     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ###################     '
    msigma=msigmamin*(msigmamax/msigmamin)**(real(i,kp)/real(Nmsigma,kp))
    !msigma=msigmamax*exp(log(msigmamin/msigmamax)*1._kp/(1._kp+10._kp*real(i,kp)/real(Nmsigma,kp))) !prefers sampling higher values
    Gammaphimax=msigma!*security
    do j=0,NGammaphi
      !Gammaphi=Gammaphimin*(Gammaphimax/Gammaphimin)**(real(j,kp)/real(NGammaphi,kp))
      Gammaphi=Gammaphimax*exp(log(Gammaphimin/Gammaphimax)*1._kp/(1._kp+10._kp*real(j,kp)/real(NGammaphi,kp))) !prefers sampling higher values
      Gammasigmamax=Gammaphi*security**9
      do k=0,NGammasigma
        !Gammasigma=Gammasigmamin*(Gammasigmamax/Gammasigmamin)**(real(j,kp)/real(NGammasigma,kp))
        Gammasigma=Gammasigmamax*exp(log(Gammasigmamin/Gammasigmamax)*1._kp/(1._kp+10._kp*real(k,kp)/real(NGammasigma,kp))) !prefers sampling higher values
        sigmaendmax=MC5_sigmaend_max(msigma,Gammaphi,Gammasigma)*security
        sigmaendmin=MC5_sigmaend_min(msigma,Gammaphi,Gammasigma)/security
        do l=0,Nsigmaend
          sigmaend=sigmaendmin*(sigmaendmax/sigmaendmin)**(real(l,kp)/real(Nsigmaend,kp))
          !sigmaend=sigmaendmax*exp(log(sigmaendmin/sigmaendmax)*1._kp/(1._kp+100._kp*real(l,kp)/real(Nsigmaend,kp))) !prefers sampling higher values
          if (mclfi5_isnormalizable(p, msigma, Gammaphi, Gammasigma, sigmaend)) then
            M = mclfi5_M(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            ns = mclfi5_ns(p, msigma, Gammaphi, Gammasigma, sigmaend)
            r = mclfi5_r(p, msigma, Gammaphi, Gammasigma, sigmaend)
            fnl = mclfi5_fnl(p, msigma, Gammaphi, Gammasigma, sigmaend)
            Psigma = mclfi5_Pzeta_sigma(p, msigma, Gammaphi, Gammasigma, sigmaend)
            Vparam%real1 = M
            bfoldstar = mclfi5_bfoldstar(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            print*, 'p=',p,'M = ',M, 'Gammaphi', Gammaphi,'msigma=', msigma, 'Gammasigma=', Gammasigma, &
                  'sigmaend', sigmaend
            print*, ' efoldstar=',-bfoldstar,' ns=',ns,' r=',r, 'fnl=',fnl, 'Psigma=',Psigma
            call livewrite('mclfi5_peq2_predic.dat',M,msigma,Gammaphi,Gammasigma,sigmaend,ns,r,fnl,Psigma)
          end if
        end do
      end do
    end do
  end do



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!                       !!!!
!!!!         p=6           !!!!
!!!!                       !!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  p=6._kp

  Vparam%real1 = M
  Vparam%real2 = p

  call delete_file('mclfi5_peq6_predic.dat')

  do i=0,Nmsigma
    print*, '     ###################     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ##  completed:   ##     '
    print*, '     ##  ',i,'/',Nmsigma,'         ##     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ###################     '
    msigma=msigmamin*(msigmamax/msigmamin)**(real(i,kp)/real(Nmsigma,kp))
    !msigma=msigmamax*exp(log(msigmamin/msigmamax)*1._kp/(1._kp+10._kp*real(i,kp)/real(Nmsigma,kp))) !prefers sampling higher values
    Gammaphimax=msigma!*security
    do j=0,NGammaphi
      !Gammaphi=Gammaphimin*(Gammaphimax/Gammaphimin)**(real(j,kp)/real(NGammaphi,kp))
      Gammaphi=Gammaphimax*exp(log(Gammaphimin/Gammaphimax)*1._kp/(1._kp+10._kp*real(j,kp)/real(NGammaphi,kp))) !prefers sampling higher values
      Gammasigmamax=Gammaphi*security**9
      do k=0,NGammasigma
        !Gammasigma=Gammasigmamin*(Gammasigmamax/Gammasigmamin)**(real(j,kp)/real(NGammasigma,kp))
        Gammasigma=Gammasigmamax*exp(log(Gammasigmamin/Gammasigmamax)*1._kp/(1._kp+10._kp*real(k,kp)/real(NGammasigma,kp))) !prefers sampling higher values
        sigmaendmax=MC5_sigmaend_max(msigma,Gammaphi,Gammasigma)*security
        sigmaendmin=MC5_sigmaend_min(msigma,Gammaphi,Gammasigma)/security
        do l=0,Nsigmaend
          sigmaend=sigmaendmin*(sigmaendmax/sigmaendmin)**(real(l,kp)/real(Nsigmaend,kp))
          !sigmaend=sigmaendmax*exp(log(sigmaendmin/sigmaendmax)*1._kp/(1._kp+100._kp*real(l,kp)/real(Nsigmaend,kp))) !prefers sampling higher values
          if (mclfi5_isnormalizable(p, msigma, Gammaphi, Gammasigma, sigmaend)) then
            M = mclfi5_M(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            ns = mclfi5_ns(p, msigma, Gammaphi, Gammasigma, sigmaend)
            r = mclfi5_r(p, msigma, Gammaphi, Gammasigma, sigmaend)
            fnl = mclfi5_fnl(p, msigma, Gammaphi, Gammasigma, sigmaend)
            Psigma = mclfi5_Pzeta_sigma(p, msigma, Gammaphi, Gammasigma, sigmaend)
            Vparam%real1 = M
            bfoldstar = mclfi5_bfoldstar(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            print*, 'p=',p,'M = ',M, 'Gammaphi', Gammaphi,'msigma=', msigma, 'Gammasigma=', Gammasigma, &
                  'sigmaend', sigmaend
            print*, ' efoldstar=',-bfoldstar,' ns=',ns,' r=',r, 'fnl=',fnl, 'Psigma=',Psigma
            call livewrite('mclfi5_peq6_predic.dat',M,msigma,Gammaphi,Gammasigma,sigmaend,ns,r,fnl,Psigma)
          end if
        end do
      end do
    end do
  end do





end program mclfi5main
