!test the massive curvaton 1 - large field inflation functions
program mcni1main
  use infprec, only : kp, transfert
  use cosmopar, only : lnRhoNuc
  use infinout, only : delete_file, livewrite
  use mcni1reheat, only : mcni1_ns, mcni1_r, mcni1_fnl, mcni1_isnormalizable, mcni1_M, &
                           mcni1_bfoldstar, mcni1_Pzeta_sigma
  use curvaton, only : MC1_sigmaend_max

  implicit none

  integer :: i, j, k, l
  integer :: Nmsigma, NGammaphi, NGammasigma, Nsigmaend
  real(kp) ::  sigmaend, msigma, Gammaphi, Gammasigma, M, f, Psigma
  real(kp) ::  Gammaphimin, Gammaphimax, Gammasigmamin, Gammasigmamax, msigmamin, msigmamax, &
               sigmaendmin, sigmaendmax
  real(kp) :: ns, r, fnl, security, bfoldstar
  type(transfert) :: Vparam

  Nmsigma = 20
  NGammaphi = 20
  NGammasigma = 10
  Nsigmaend = 20

  security = 0.6_kp

  Gammaphimin=sqrt(exp(lnRhoNuc)/3._kp)


  msigmamin = Gammaphimin
  Gammasigmamin = Gammaphimin



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!                       !!!!
!!!!        f=3 Mp         !!!!
!!!!                       !!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  f=3._kp
  M = (7._kp*10**(-9.)*exp(-100._kp/f**2)/(1._kp+2._kp*f**2))**(0.25_kp) ! Fiducial Value, valid for f=O(1)
  msigmamax = M**2

  Vparam%real1 = M
  Vparam%real2 = f

  call delete_file('mcni1_feq3_predic.dat')

  do i=0,Nmsigma
    print*, '     ###################     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ##  completed:   ##     '
    print*, '     ##  ',i,'/',Nmsigma,'         ##     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ###################     '
    msigma=msigmamin*(msigmamax/msigmamin)**(real(i,kp)/real(Nmsigma,kp))
    !msigma=msigmamax*exp(log(msigmamin/msigmamax)*1._kp/(1._kp+10._kp*real(i,kp)/real(Nmsigma,kp))) !prefers sampling higher values
    Gammasigmamax=msigma!*security
    do j=0,NGammasigma
      !Gammasigma=Gammasigmamin*(Gammasigmamax/Gammasigmamin)**(real(j,kp)/real(NGammasigma,kp))
      Gammasigma=Gammasigmamax*exp(log(Gammasigmamin/Gammasigmamax)*1._kp/(1._kp+10._kp*real(j,kp)/real(NGammasigma,kp))) !prefers sampling higher values
      Gammaphimax=Gammasigma!*security
      do k=0,NGammaphi
        !Gammaphi=Gammaphimin*(Gammaphimax/Gammaphimin)**(real(j,kp)/real(NGammaphi,kp))
        Gammaphi=Gammaphimax*exp(log(Gammaphimin/Gammaphimax)*1._kp/(1._kp+10._kp*real(k,kp)/real(NGammaphi,kp))) !prefers sampling higher values
        sigmaendmax=MC1_sigmaend_max(msigma,Gammaphi,Gammasigma)*security
        sigmaendmin=sigmaendmax/1000._kp
        do l=0,Nsigmaend
          !sigmaend=sigmaendmin*(sigmaendmax/sigmaendmin)**(real(l,kp)/real(Nsigmaend,kp))
          sigmaend=sigmaendmax*exp(log(sigmaendmin/sigmaendmax)*1._kp/(1._kp+100._kp*real(l,kp)/real(Nsigmaend,kp))) !prefers sampling higher values
          if (mcni1_isnormalizable(f, msigma, Gammaphi, Gammasigma, sigmaend)) then
            M = mcni1_M(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            ns = mcni1_ns(f, msigma, Gammaphi, Gammasigma, sigmaend)
            r = mcni1_r(f, msigma, Gammaphi, Gammasigma, sigmaend)
            fnl = mcni1_fnl(f, msigma, Gammaphi, Gammasigma, sigmaend)
            Psigma = mcni1_Pzeta_sigma(f, msigma, Gammaphi, Gammasigma, sigmaend)
            Vparam%real1 = M
            bfoldstar = mcni1_bfoldstar(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            print*, 'f=',f,'M = ',M, 'Gammaphi', Gammaphi,'msigma=', msigma, 'Gammasigma=', Gammasigma, &
                  'sigmaend/sigmaendmax=', sigmaend/sigmaendmax*security
            print*, ' efoldstar=',-bfoldstar,' ns=',ns,' r=',r, 'fnl=',fnl, 'Psigma=',Psigma
            call livewrite('mcni1_feq3_predic.dat',M,msigma,Gammaphi,Gammasigma,sigmaend,ns,r,fnl,Psigma)
          end if
        end do
      end do
    end do
  end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!                       !!!!
!!!!        f=6 Mp         !!!!
!!!!                       !!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  f=6._kp
  M = (3.35_kp*10**(-9.)*f**2/50._kp**2)**0.25_kp ! Fiducial Value, valid for f>>1
  msigmamax = M**2

  Vparam%real1 = M
  Vparam%real2 = f

  call delete_file('mcni1_feq6_predic.dat')

  do i=0,Nmsigma
    print*, '     ###################     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ##  completed:   ##     '
    print*, '     ##  ',i,'/',Nmsigma,'         ##     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ###################     '
    msigma=msigmamin*(msigmamax/msigmamin)**(real(i,kp)/real(Nmsigma,kp))
    !msigma=msigmamax*exp(log(msigmamin/msigmamax)*1._kp/(1._kp+10._kp*real(i,kp)/real(Nmsigma,kp))) !prefers sampling higher values
    Gammasigmamax=msigma!*security
    do j=0,NGammasigma
      !Gammasigma=Gammasigmamin*(Gammasigmamax/Gammasigmamin)**(real(j,kp)/real(NGammasigma,kp))
      Gammasigma=Gammasigmamax*exp(log(Gammasigmamin/Gammasigmamax)*1._kp/(1._kp+10._kp*real(j,kp)/real(NGammasigma,kp))) !prefers sampling higher values
      Gammaphimax=Gammasigma!*security
      do k=0,NGammaphi
        !Gammaphi=Gammaphimin*(Gammaphimax/Gammaphimin)**(real(j,kp)/real(NGammaphi,kp))
        Gammaphi=Gammaphimax*exp(log(Gammaphimin/Gammaphimax)*1._kp/(1._kp+10._kp*real(k,kp)/real(NGammaphi,kp))) !prefers sampling higher values
        sigmaendmax=MC1_sigmaend_max(msigma,Gammaphi,Gammasigma)*security
        sigmaendmin=sigmaendmax/1000._kp
        do l=0,Nsigmaend
          !sigmaend=sigmaendmin*(sigmaendmax/sigmaendmin)**(real(l,kp)/real(Nsigmaend,kp))
          sigmaend=sigmaendmax*exp(log(sigmaendmin/sigmaendmax)*1._kp/(1._kp+100._kp*real(l,kp)/real(Nsigmaend,kp))) !prefers sampling higher values
          if (mcni1_isnormalizable(f, msigma, Gammaphi, Gammasigma, sigmaend)) then
            M = mcni1_M(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            ns = mcni1_ns(f, msigma, Gammaphi, Gammasigma, sigmaend)
            r = mcni1_r(f, msigma, Gammaphi, Gammasigma, sigmaend)
            fnl = mcni1_fnl(f, msigma, Gammaphi, Gammasigma, sigmaend)
            Psigma = mcni1_Pzeta_sigma(f, msigma, Gammaphi, Gammasigma, sigmaend)
            Vparam%real1 = M
            bfoldstar = mcni1_bfoldstar(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            print*, 'f=',f,'M = ',M, 'Gammaphi', Gammaphi,'msigma=', msigma, 'Gammasigma=', Gammasigma, &
                  'sigmaend/sigmaendmax=', sigmaend/sigmaendmax*security
            print*, ' efoldstar=',-bfoldstar,' ns=',ns,' r=',r, 'fnl=',fnl, 'Psigma=',Psigma
            call livewrite('mcni1_feq6_predic.dat',M,msigma,Gammaphi,Gammasigma,sigmaend,ns,r,fnl,Psigma)
          end if
        end do
      end do
    end do
  end do





end program mcni1main
