!test the massive curvaton 10 - power law inflation functions
program mcpli10main
  use infprec, only : kp, transfert
  use cosmopar, only : lnRhoNuc
  use infinout, only : delete_file, livewrite
  use mcplisr, only : mcpli_potential,mcpli_phiend0
  use mcpli10reheat, only : mcpli10_ns, mcpli10_r, mcpli10_fnl, mcpli10_isnormalizable, &
                            mcpli10_M, mcpli10_bfoldstar, mcpli10_Pzeta_sigma
  use curvaton, only : MC10_sigmaend_min, MC10_sigmaend_max

  implicit none

  integer :: i, j, k, l
  integer :: Nmsigma, NGammaphi, NGammasigma, Nsigmaend
  real(kp) ::  sigmaend, msigma, Gammaphi, Gammasigma, M, alpha, Psigma
  real(kp) ::  Gammaphimin, Gammaphimax, Gammasigmamin, Gammasigmamax, msigmamin, msigmamax, &
               sigmaendmin, sigmaendmax
  real(kp) :: ns, r, fnl, security, bfoldstar
  type(transfert) :: Vparam

  real(kp), parameter :: junkphiend = 100._kp

  Nmsigma = 20
  NGammaphi = 20
  NGammasigma = 10
  Nsigmaend = 20

  security = 0.8_kp

  Gammasigmamin=sqrt(exp(lnRhoNuc)/3._kp)


  Gammaphimin = Gammasigmamin/security**9
  msigmamin = Gammasigmamin/security**9

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!                       !!!!
!!!!      alpha=0.02       !!!!
!!!!                       !!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  alpha=0.02_kp
  M = (720._kp*acos(-1._kp)**2*alpha**2*exp(-alpha**2*50._kp)*2._kp*10._kp**(-9.)/60._kp*exp(alpha*junkphiend))**(0.25_kp)! Fiducial Value
  Gammaphimax = M**2

  Vparam%real1 = M
  Vparam%real2 = alpha

  call delete_file('mcpli10_alphaeqpoint02_predic.dat')

  do i=0,NGammaphi
    print*, '     ###################     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ##  completed:   ##     '
    print*, '     ##  ',i,'/',Nmsigma,'         ##     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ###################     '
    Gammaphi=Gammaphimin*(Gammaphimax/Gammaphimin)**(real(i,kp)/real(NGammaphi,kp))
    !Gammaphi=Gammaphimax*exp(log(Gammaphimin/Gammaphimax)*1._kp/(1._kp+10._kp*real(i,kp)/real(NGammaphi,kp))) !prefers sampling higher values
    msigmamax=Gammaphi!*security
    msigmamin=sqrt(6._kp)*Gammaphi/20._kp ! just to avoid wasting useless parameter space exploration. . Otherwise, would be Gammasigmamin.
    do j=0,Nmsigma
      !msigma=msigmamin*(msigmamax/msigmamin)**(real(j,kp)/real(Nmsigma,kp))
      msigma=msigmamax*exp(log(msigmamin/msigmamax)*1._kp/(1._kp+10._kp*real(j,kp)/real(Nmsigma,kp))) !prefers sampling higher values
      Gammasigmamax=msigma!*security**9
      do k=0,NGammasigma
        !Gammasigma=Gammasigmamin*(Gammasigmamax/Gammasigmamin)**(real(j,kp)/real(NGammasigma,kp))
        Gammasigma=Gammasigmamax*exp(log(Gammasigmamin/Gammasigmamax)*1._kp/(1._kp+10._kp*real(k,kp)/real(NGammasigma,kp))) !prefers sampling higher values
        sigmaendmax=20._kp ! 20 is to avoid wasting exploring useless parameters space (if sigmaend>20, impossible to normalize M)
        sigmaendmin=MC10_sigmaend_min(msigma,Gammaphi,Gammasigma)/security
        do l=0,Nsigmaend
          sigmaend=sigmaendmin*(sigmaendmax/sigmaendmin)**(real(l,kp)/real(Nsigmaend,kp))
          if (mcpli10_isnormalizable(alpha, msigma, Gammaphi, Gammasigma, sigmaend)) then
            M = mcpli10_M(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            Vparam%real1 = M
            if (sigmaend < MC10_sigmaend_max(mcpli_potential,mcpli_phiend0,&
                    Vparam,msigma,Gammaphi,Gammasigma)) then ! check that sigmaend does not domimate the energy content at the end of inflation
              ns = mcpli10_ns(alpha, msigma, Gammaphi, Gammasigma, sigmaend)
              r = mcpli10_r(alpha, msigma, Gammaphi, Gammasigma, sigmaend)
              fnl = mcpli10_fnl(alpha, msigma, Gammaphi, Gammasigma, sigmaend)
              Psigma = mcpli10_Pzeta_sigma(alpha, msigma, Gammaphi, Gammasigma, sigmaend)
              Vparam%real1 = M
              bfoldstar = mcpli10_bfoldstar(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
              print*, 'alpha=',alpha,'M = ',M, 'Gammaphi', Gammaphi,'msigma=', msigma, 'Gammasigma=', Gammasigma, &
                  'sigmaend=', sigmaend
              print*, ' efoldstar=',-bfoldstar,' ns=',ns,' r=',r, 'fnl=',fnl, 'Psigma=',Psigma
              call livewrite('mcpli10_alphaeqpoint02_predic.dat',M,msigma,Gammaphi,Gammasigma,sigmaend,ns,r,fnl,Psigma)
            end if
          end if
        end do
      end do
    end do
  end do



end program mcpli10main
