!test the massive curvaton 1 - power law inflation functions
program mcpli5main
  use infprec, only : kp, transfert
  use cosmopar, only : lnRhoNuc
  use infinout, only : delete_file, livewrite
  use mcpli5reheat, only : mcpli5_ns, mcpli5_r, mcpli5_fnl, mcpli5_isnormalizable, mcpli5_M, &
                           mcpli5_bfoldstar, mcpli5_Pzeta_sigma
  use curvaton, only : MC5_sigmaend_min, MC5_sigmaend_max

  implicit none

  integer :: i, j, k, l
  integer :: Nmsigma, NGammaphi, NGammasigma, Nsigmaend
  real(kp) ::  sigmaend, msigma, Gammaphi, Gammasigma, M, alpha, Psigma
  real(kp) ::  Gammaphimin, Gammaphimax, Gammasigmamin, Gammasigmamax, msigmamin, msigmamax, &
               sigmaendmin, sigmaendmax
  real(kp) :: ns, r, fnl, security, bfoldstar
  type(transfert) :: Vparam

  real(kp), parameter :: junkphiend = 100._kp

  Nmsigma = 20
  NGammaphi = 20
  NGammasigma = 10
  Nsigmaend = 20

  security = 0.8_kp

  Gammasigmamin=sqrt(exp(lnRhoNuc)/3._kp)


  msigmamin = Gammasigmamin/security**9
  Gammaphimin = Gammasigmamin/security**9

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!                       !!!!
!!!!      alpha=0.02       !!!!
!!!!                       !!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  alpha=0.02_kp
  M = (720._kp*acos(-1._kp)**2*alpha**2*exp(-alpha**2*50._kp)*2._kp*10._kp**(-9.)/60._kp*exp(alpha*junkphiend))**(0.25_kp)! Fiducial Value
  msigmamax = M**2

  Vparam%real1 = M
  Vparam%real2 = alpha

  call delete_file('mcpli5_alphaeqpoint02_predic.dat')

  do i=0,Nmsigma
    print*, '     ###################     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ##  completed:   ##     '
    print*, '     ##  ',i,'/',Nmsigma,'         ##     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ###################     '
    msigma=msigmamin*(msigmamax/msigmamin)**(real(i,kp)/real(Nmsigma,kp))
    !msigma=msigmamax*exp(log(msigmamin/msigmamax)*1._kp/(1._kp+10._kp*real(i,kp)/real(Nmsigma,kp))) !prefers sampling higher values
    Gammaphimax=msigma!*security
    do j=0,NGammaphi
      !Gammaphi=Gammaphimin*(Gammaphimax/Gammaphimin)**(real(j,kp)/real(NGammaphi,kp))
      Gammaphi=Gammaphimax*exp(log(Gammaphimin/Gammaphimax)*1._kp/(1._kp+10._kp*real(j,kp)/real(NGammaphi,kp))) !prefers sampling higher values
      Gammasigmamax=Gammaphi*security**9
      do k=0,NGammasigma
        !Gammasigma=Gammasigmamin*(Gammasigmamax/Gammasigmamin)**(real(j,kp)/real(NGammasigma,kp))
        Gammasigma=Gammasigmamax*exp(log(Gammasigmamin/Gammasigmamax)*1._kp/(1._kp+10._kp*real(k,kp)/real(NGammasigma,kp))) !prefers sampling higher values
        sigmaendmax=MC5_sigmaend_max(msigma,Gammaphi,Gammasigma)*security
        sigmaendmin=MC5_sigmaend_min(msigma,Gammaphi,Gammasigma)/security
        do l=0,Nsigmaend
          sigmaend=sigmaendmin*(sigmaendmax/sigmaendmin)**(real(l,kp)/real(Nsigmaend,kp))
          !sigmaend=sigmaendmax*exp(log(sigmaendmin/sigmaendmax)*1._kp/(1._kp+100._kp*real(l,kp)/real(Nsigmaend,kp))) !prefers sampling higher values
          if (mcpli5_isnormalizable(alpha, msigma, Gammaphi, Gammasigma, sigmaend)) then
            M = mcpli5_M(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            ns = mcpli5_ns(alpha, msigma, Gammaphi, Gammasigma, sigmaend)
            r = mcpli5_r(alpha, msigma, Gammaphi, Gammasigma, sigmaend)
            fnl = mcpli5_fnl(alpha, msigma, Gammaphi, Gammasigma, sigmaend)
            Psigma = mcpli5_Pzeta_sigma(alpha, msigma, Gammaphi, Gammasigma, sigmaend)
            Vparam%real1 = M
            bfoldstar = mcpli5_bfoldstar(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            print*, 'alpha=',alpha,'M = ',M, 'Gammaphi', Gammaphi,'msigma=', msigma, 'Gammasigma=', Gammasigma, &
                  'sigmaend', sigmaend
            print*, ' efoldstar=',-bfoldstar,' ns=',ns,' r=',r, 'fnl=',fnl, 'Psigma=',Psigma
            call livewrite('mcpli5_alphaeqpoint02_predic.dat',M,msigma,Gammaphi,Gammasigma,sigmaend,ns,r,fnl,Psigma)
          end if
        end do
      end do
    end do
  end do




end program mcpli5main
