!test the massive curvaton 7 - power law inflation functions
program mcpli7main
  use infprec, only : kp, transfert
  use cosmopar, only : lnRhoNuc
  use infinout, only : delete_file, livewrite
  use mcpli7reheat, only : mcpli7_ns, mcpli7_r, mcpli7_fnl, mcpli7_isnormalizable, mcpli7_M, &
                           mcpli7_bfoldstar, mcpli7_Pzeta_sigma
  use curvaton, only : MC7_sigmaend_max

  implicit none

  integer :: i, j, k, l
  integer :: Nmsigma, NGammaphi, NGammasigma, Nsigmaend
  real(kp) ::  sigmaend, msigma, Gammaphi, Gammasigma, M, alpha, Psigma
  real(kp) ::  Gammaphimin, Gammaphimax, Gammasigmamin, Gammasigmamax, msigmamin, msigmamax, &
               sigmaendmin, sigmaendmax
  real(kp) :: ns, r, fnl, security, bfoldstar
  type(transfert) :: Vparam

  real(kp), parameter :: junkphiend = 100._kp

  Nmsigma = 20
  NGammaphi = 20
  NGammasigma = 10
  Nsigmaend = 20

  security = 0.5_kp

  Gammasigmamin=sqrt(exp(lnRhoNuc)/3._kp)


  Gammaphimin = Gammasigmamin
  msigmamin = Gammasigmamin


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!                       !!!!
!!!!      alpha=0.02       !!!!
!!!!                       !!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  alpha=0.02_kp
  M = (720._kp*acos(-1._kp)**2*alpha**2*exp(-alpha**2*50._kp)*2._kp*10._kp**(-9.)/60._kp*exp(alpha*junkphiend))**(0.25_kp)! Fiducial Value
  Gammaphimax = M**2

  Vparam%real1 = M
  Vparam%real2 = alpha

  call delete_file('mcpli7_alphaeqpoint02_predic.dat')

  do i=0,NGammaphi
    print*, '     ###################     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ##  completed:   ##     '
    print*, '     ##  ',i,'/',Nmsigma,'         ##     '
    print*, '     ##               ##     '
    print*, '     ##               ##     '
    print*, '     ###################     '
    Gammaphi=Gammaphimin*(Gammaphimax/Gammaphimin)**(real(i,kp)/real(NGammaphi,kp))
    !Gammaphi=Gammaphimax*exp(log(Gammaphimin/Gammaphimax)*1._kp/(1._kp+10._kp*real(i,kp)/real(NGammaphi,kp))) !prefers sampling higher values
    msigmamax=Gammaphi!*security
    !msigmamin=msigmamax/1000._kp
    do j=0,Nmsigma
      !msigma=msigmamin*(msigmamax/msigmamin)**(real(j,kp)/real(Nmsigma,kp))
      msigma=msigmamax*exp(log(msigmamin/msigmamax)*1._kp/(1._kp+10._kp*real(j,kp)/real(Nmsigma,kp))) !prefers sampling higher values
      Gammasigmamax=msigma!*security
      do k=0,NGammasigma
        !Gammasigma=Gammasigmamin*(Gammasigmamax/Gammasigmamin)**(real(j,kp)/real(NGammasigma,kp))
        Gammasigma=Gammasigmamax*exp(log(Gammasigmamin/Gammasigmamax)*1._kp/(1._kp+10._kp*real(k,kp)/real(NGammasigma,kp))) !prefers sampling higher values
        sigmaendmax=MC7_sigmaend_max(msigma,Gammaphi,Gammasigma)*security
        sigmaendmin=sigmaendmax/1000._kp
        do l=0,Nsigmaend
          sigmaend=sigmaendmin*(sigmaendmax/sigmaendmin)**(real(l,kp)/real(Nsigmaend,kp))
          if (mcpli7_isnormalizable(alpha, msigma, Gammaphi, Gammasigma, sigmaend)) then
            M = mcpli7_M(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            ns = mcpli7_ns(alpha, msigma, Gammaphi, Gammasigma, sigmaend)
            r = mcpli7_r(alpha, msigma, Gammaphi, Gammasigma, sigmaend)
            fnl = mcpli7_fnl(alpha, msigma, Gammaphi, Gammasigma, sigmaend)
            Psigma = mcpli7_Pzeta_sigma(alpha, msigma, Gammaphi, Gammasigma, sigmaend)
            Vparam%real1 = M
            bfoldstar = mcpli7_bfoldstar(Vparam, msigma, Gammaphi, Gammasigma, sigmaend)
            print*, 'alpha=',alpha,'M = ',M, 'Gammaphi', Gammaphi,'msigma=', msigma, 'Gammasigma=', Gammasigma, &
                  'sigmaend=', sigmaend
            print*, ' efoldstar=',-bfoldstar,' ns=',ns,' r=',r, 'fnl=',fnl, 'Psigma=',Psigma
            call livewrite('mcpli7_alphaeqpoint02_predic.dat',M,msigma,Gammaphi,Gammasigma,sigmaend,ns,r,fnl,Psigma)
          end if
        end do
      end do
    end do
  end do



end program mcpli7main
